// var alertData;

Alert_TIMEOUT = 10000;
function Alert_retrieve(callback, error_loading) {
  var url = Alert_createURL(error_loading);
  var hasBeenLoaded = false;
  
  Alert_reset(callback);

  var request = new XMLHttpRequest();
  if (!request) {if (error_loading) {error_loading();} return;}
  request.onreadystatechange = onReadyStateChange;
  if (request.overrideMimeType) request.overrideMimeType('text/xml');
  request.open("GET", url, true);
  request.setRequestHeader("Cache-Control", "no-cache");
  
  var requestTimeout = view.setTimeout(function() { request.abort(); if (error_loading) {error_loading();}}, Alert_TIMEOUT);   
  
  request.send();


  function onReadyStateChange() {
    if (request.readyState != 4 || hasBeenLoaded == true) {
      return;
    }
    hasBeenLoaded = true;
	
    view.clearTimeout(requestTimeout);
    
    if (request.status == 200) {
      debug.trace("Alert_parseData loaded");
      Alert_parseData(request.responseXML, callback, error_loading);
    } else {
      if (error_loading) {
        error_loading(); 
      }
		  if (connection.isGood) connection.hasProblem();      
    }
  }
}
function Alert_createURL(error_loading) {
  
	var url = prefs.get("url");
	if (url == null || url == '') {
		debug.error("Alert_createURL: no url");
		if (error_loading) error_loading();
	}
  //add t={num} to URL so we force refresh
//	return "http://api.wunderground.com/auto/wui/geo/AlertsXML" + url + "?t=" + new Date().getTime();
	return "http://api.wunderground.com/api/3ffab52910ec1a0e/alerts/q/" + prefs.get("query") + ".xml?t=" + new Date().getTime();
}
function Alert_reset(callback) {
	var alerts = new Array();
	if (callback) callback(alerts);
}
function Alert_parseData (xml, callback, error_loading) {
	var alerts = new Array();
	var alertItem; var alertsNode;
	var alertNode;
	var count;

	try {
		var response = new Object();
		var responseNode = findChild(xml,"response");

		var alertsNode = findChild(responseNode,"alerts");
		if ((alertNode = findChild(alertsNode,"alert")) != null) {	
			count = alertNode.getAttribute("count");
			if (count > 0) {//we have an alert
			  alertItem = findChildList(alertNode,"AlertItem");
		    for (var i = 0; i < count; i++){
				alertsChild = new Object();
				alertsChild.description = findChildData(alertItem[i],"description");
				alertsChild.type = findChildData(alertItem[i],"type");
				alertsChild.date = findChildData(alertItem[i],"date");
				alertsChild.longSummary = findChildData(alertItem[i],"message");
				alerts.push(alertsChild);}
			}
		}
	} catch(e) {
		debug.error("Alert: " + e.message);
		if (error_loading) {
			error_loading();
		}
		if (connection) connection.hasProblem();
	}

	if (callback) callback(alerts);
}
function Alert_errorLoading() {
	debug.error("Alert_errorLoading: connection problem");
}
