var loc;
var stations;
var nearestAirportId;
var locationsList;
var Query_hadVagueLocation;
var Query_dividerIndex;
var view = window;
var Query_TIMEOUT = 6000;

function Query_retrieve(qry, inputUrl, error_loading) {
  var url = Query_createURL(qry, inputUrl);
  var Query_url = "http://api.wunderground.com/api/3ffab52910ec1a0e/geolookup/radar/webcams/q/"+url;
  var hasBeenLoaded = false;
  
  if (!url) {if (error_loading) error_loading(); main.debug.error("Query_retrieve: bad query"); return false;}

	show('loading_back');
	Settings_showOnly(null);

  var request = new XMLHttpRequest();
  if (!request) {if (error_loading) {error_loading();} return;}
  request.onreadystatechange = onReadyStateChange;
  if (request.overrideMimeType) request.overrideMimeType('text/xml');
  request.open("GET", Query_url, true);
  request.setRequestHeader("Cache-Control", "no-cache");
  
  var requestTimeout = view.setTimeout(function() { request.abort(); if (error_loading) {error_loading();}}, Query_TIMEOUT);   
  
  request.send();

  function onReadyStateChange() {
    if (request.readyState != 4 || hasBeenLoaded == true) {
      return;
    }
	  hasBeenLoaded = true;
	  
    view.clearTimeout(requestTimeout);
    
    if (request.status == 200) {
			main.debug.trace("Query_parseData loaded");
			main.connection.hasNoProblem();
      Query_parseData(request.responseXML, url, error_loading);
    } else { //request failed
      Query_connectionProblem();
    }
  }
}
function Query_createURL(qry, inputUrl) {
	var url;
//	if (qry) url = "/index.xml?query="+escape(qry) + "&t=" + new Date().getTime();
	if (qry) url = qry + ".xml?t=" + new Date().getTime();
	else url = inputUrl + ".xml?t=" + new Date().getTime();
	return url;
}

function Query_parseData(xml, url, error_loading) {
	
	main.debug.trace("xml: ["+(xml.firstChild)+"]");
	main.debug.trace("to: "+typeof xml);
	
	try {
	var locationsXML;
	
	var type;
	var locNode;
	
	//code to prevent weird characters from making MSXML panic
  if (!xml.firstChild) throw(new (function(){this.message = "XML loading error."; this.name ="XMLParsingError";}));
	
	var locationsXML = findChild(xml,'locations');
//	var locationsXML = findChild(xml,'response');
	
	if (findChild(xml,"wui_error") != null || findChild(xml,"parseerror")) {
		
		if (error_loading) error_loading();
			
	} else if (locationsXML != null) {
		//means we have a vague case, have the user decide which location is the right one

		Query_hadVagueLocation = true;
		hide('loading_back');
		locations = findChildList(locationsXML,"location");
		Query_showVagueLocations(locations);
		
	} else if (xml != null) {
		var response = new Object();
		var responseNodeL = findChild(xml,"response");
		loc = new Object();	
		var locNode = findChild(responseNodeL,"location");
		var niceUrl = findChildData(locNode,"requesturl");
		main.prefs.set("niceUrl",niceUrl);
		main.prefs.set("url",url);
		var city = findChildData(locNode,"city");
		loc.city = city;
		main.prefs.set("location",loc.city);
		loc.state = findChildData(locNode,"state");
		loc.country = findChildData(locNode,"country");
		loc.wuiurl = findChildData(locNode,"wuiurl");
		
		//store radar
		var response = new Object();
		var responseNodeR = findChild(xml,"response");
		var radar = findChild(responseNodeR,"radar");
		loc.radar = new Object();
		if (radar != null) {
			loc.radar.image = findChildData(radar,"image_url");
			loc.radar.url = findChildData(radar,"url");
			if (loc.radar.image != null) {
				loc.radar.image += "%26num=5%26width="+130+"%26height="+130+"&width="+130+"&height="+130;
				loc.radar.image += "&time=" + main.now();
			}
		}
		
		//store webcams
		var response = new Object();
		var responseNodeR = findChild(xml,"response");
		loc.webcams = new Array();
		var webcamNode = findChild(locNode,"webcams");
		if (webcamNode != null) {
			var cams = webcamNode.getElementsByTagName('cam');
			if (cams) {for (var i = 0; i < cams.length; i++) {
				var webcam = new Object();
				webcam.url = findChildData(cams.item(i),"WIDGETCURRENTIMAGEURL");
				if (webcam.url) webcam.url = webcam.url + "&time=" + main.now();
				webcam.camUrl = findChildData(cams.item(i),"CAMURL");
				webcam.city = findChildData(cams.item(i),"city");
				webcam.handle = findChildData(cams.item(i),"handle");
				loc.webcams.push(webcam);
			}}
		}
		
    main.prefs.set("selectedWebcam", loc.webcams.length > 0 ? 0 : "");
    main.loc = loc;
    main.prefs.set("loc",loc);

		//set the UI elements for webcams and radar

		//get local wx station information
		var lat = findChildData(locNode,"lat");
		var lon = findChildData(locNode,"lon");
		var nearby_stations = findChild(locNode,"nearby_weather_stations");
    
		//FORECAST DATA
    main.Forecast_retrieve(main.setForecast, main.Forecast_errorLoading);
		
		//load alert data
    main.Alert_retrieve(main.setAlert,main.Alert_errorLoading);

		Query_parseLocalWxStns(nearby_stations,lat,lon);		
			
	} else { //probably a connection problem
		Query_connectionProblem();
	}
	} catch(e) {
	  if (e.name == "XMLParsingError") {
	    Query_XMLParseError();
	  } else {
	    Query_connectionProblem();
	  }
		main.debug.error("Query_parseData: " + e.message);
	}
}

//if there are multiple locations from the input
function Query_showVagueLocations (locs) {

	locationsList = new Array();
	for (var i = 0; i < locs.length; i++) {
		locationObj = {	"name":findChildData(locs[i],"name"), 
						"type": locs[i].getAttribute("type").toLowerCase(),
						"value":findChildData(locs[i],"link")
						};
		locationsList.push(locationObj);
	}
	
	locationsList.unshift({"name":main.getLocalizedString("Select a location"),"value":null,"disabled":true,"selected":true});
	
	makeSelectBox("vagueLocationSelect",locationsList,Query_locationVagueOnChange);
	
	Settings_showOnly(['vagueLocationLabel','vagueLocationSelect']);
  $('vagueLocationSelect').focus();
}

function Query_locationVagueOnChange () {
	
	var selected = $("vagueLocationSelect").selectedIndex;
	
	$('zip').value = query = locationsList[selected].name;
	main.prefs.set("query",query);
	var url = locationsList[selected].value;
	delete locationsList;
	
	Query_retrieve(null,url,Query_errorLoading);
}

function Query_connectionProblem () {
	main.debug.error("Query_connectionProblem: connection problem");
	hide('loading_back');
	Settings_showOnly('connectionProblem');
	main.connection.hasProblem();
}
function Query_XMLParseError () {
	hide('loading_back');
	Settings_showOnly('XMLParseError');
}

function Query_errorLoading () {
	main.debug.error("Query_errorLoading: loading error");
	hide('loading_back');
	Settings_showOnly('locationNotFound');
}


function Query_parseLocalWxStns (nearby_weather_stations,lat1,lon1) {
	var airport;
	var pws;
	var stationsNode;
	var pwsNode;
	var station;
	var lat2; var lon2;
	var distance_km; var distance_mi;
	
	try {
	airport = findChild(nearby_weather_stations,"airport");
	pws = findChild(nearby_weather_stations,"pws");
  
	stations = new Array();
	
	//airports
	stationsNode = findChildList(airport,"station");
	
	for (var i = 0; i < stationsNode.length; i++) {
		lat2 = findChildData(stationsNode[i],"lat");
		lon2 = findChildData(stationsNode[i],"lon");
		distance_km = getDistance(lat1,lon1,lat2,lon2);
		distance_mi = distance_km / 1.609344;
		
		station = {
			"neighborhood": null,
			"city"		: findChildData(stationsNode[i],"city"),
			"state"  	: findChildData(stationsNode[i],"state"),
			"country"  	: findChildData(stationsNode[i],"country"),			
			"type"		: "airport",
			"distance_km": distance_km, //round to 2 decimal places
			"distance_mi": distance_mi,
			"id"  		: findChildData(stationsNode[i],"icao")						
		};
		stations.push(station);	
	}
	//load the nearest icao station so we can get the conditions icon
	if (stations.length && stations.length > 0) {
		nearestAirportId = stations[0].id;
		
    main.prefs.set("subLocation",outputLocalWxStnTitle(stations[0]));
    main.prefs.set("airport",stations[0].id);
    main.prefs.set("PWS","");
    done_button.eventClick(Gadget_useDefaultAirport);
	}
	
	Query_dividerIndex = stations.length;
	
	//PWS
	pwsNode = findChildList(pws,"station");
	for (var i = 0; i < pwsNode.length; i++) {
		station = {
			"neighborhood": findChildData(pwsNode[i],"neighborhood"),
			"city"		: findChildData(pwsNode[i],"city"),
			"state"  	: findChildData(pwsNode[i],"state"),
			"country"  	: findChildData(pwsNode[i],"country"),			
			"type"		:"pws",
			"distance_mi": findChildData(pwsNode[i],"distance_mi"),
			"distance_km": findChildData(pwsNode[i],"distance_km"),
			"id"  		: findChildData(pwsNode[i],"id")						
		};
		stations.push(station);	
	}

	hide('loading_back');
	
	if (stations.length == 0) { //no local stations at all
		
		//load the forecast ICAO as the default localWxStn
		Settings_showOnly(null);
		main.prefs.set("subLocation",'');
		main.prefs.set("PWS","");
		main.prefs.set("airport","");
    done_button.reset();
		
    main.setCurConds(new Object(),false,'none');
		
	} else if (stations.length == 1) {//no choice, use the only station present

		Settings_showOnly(null);
		if (stations[0].type == "airport") {
			main.prefs.set("airport",stations[0].id);
			main.prefs.set("PWS","");
		} else {
			main.prefs.set("airport","");
			main.prefs.set("PWS",stations[0].id);
		}
    main.prefs.set("subLocation",outputLocalWxStnTitle(stations[0]));
    done_button.reset();
		
		if (stations[0].type == 'airport') {
      main.CurCond_retrieve('airport',false,main.setCurConds, main.CurCond_errorLoading);
		} else if (stations[0].type == 'pws'){
      main.CurCond_retrieve('pws',false,main.setCurConds, main.CurCond_errorLoading);
		}

	} else { //multiple local wx stations
		
		Query_showLocalWxStns();		
		
	}
	} catch(e) {
    hide('loading_back');
		main.debug.error("Query_parseLocalWxStns: "+e.message);
		Query_errorLoading();
	}

}

function Query_showLocalWxStns () {
	
	try {
	var units = main.prefs.get("units");
	var name;
	var distance;
	var stations_sorted;
	var stn;
	var select_entry;
	var select_entries = new Array();
	
	select_entries.push({"name":main.getLocalizedString("Airports"),"value":null,"optgroup":true,"selected":true});

	stations_sorted = stations;

	for(var i = 0; i < stations_sorted.length; i++) {
	  if (Query_dividerIndex == i) select_entries.push({"name":main.getLocalizedString("Personal Weather Stations"),"value":null,"optgroup":true,"selected":false});
		stn = stations_sorted[i];
		
		name = outputLocalWxStnTitle(stn);
		distance = Math.round(units == 0 ? stn.distance_mi : stn.distance_km);

		if (distance > 0)
			name += " [" + distance + (units == 0?" mi":" km") + "]";
		
		select_entry = {
			"name"		: name,
			"value"		: i
		};
		select_entries.push(select_entry);
	}
	
	var localSelect = $('localWxStationSelect');
	var localSelectLabel = $('localWxStationLabel');
	
	makeSelectBox('localWxStationSelect',select_entries,Query_LocalWxStnsOnChange);
	
	if (Query_hadVagueLocation == true) {

		$('vagueLocationSelect').disabled = true;
		$('vagueLocationLabel').style.color = "#aaa";
		Settings_showOnly(['localWxStationSelect','localWxStationLabel','vagueLocationSelect','vagueLocationLabel']);
		
	} else { 
		$('vagueLocationSelect').disabled = false;
		$('vagueLocationLabel').style.color = "#000";
		Settings_showOnly(['localWxStationSelect','localWxStationLabel']);
	}
} catch(e) {
		main.debug.error("Query_showLocalWxStns: "+e.message);  
}

  // localSelect.focus();
}

function Query_LocalWxStnsOnChange () {
	
	var selected = $('localWxStationSelect').selectedIndex;
		
		done_button.reset();
		
		var stnName = outputLocalWxStnTitle(stations[selected]);
		
		main.debug.trace("Query_LocalWxStnsOnChange: "+stnName);
		
		if (stations[selected].type == "airport") {

			main.prefs.set("airport",stations[selected].id);
			main.prefs.set("PWS","");
		
      main.CurCond_retrieve('airport',false,main.setCurConds, main.CurCond_errorLoading);
		
		} else {
		
			main.prefs.set("airport",nearestAirportId);
			main.prefs.set("PWS",stations[selected].id);

      main.CurCond_retrieve('airport',true,main.setCurConds, main.CurCond_errorLoading); //true so we don't overwrite pws data (only loads icon)
      main.CurCond_retrieve('pws',false,main.setCurConds, main.CurCond_errorLoading); 
			
		}
		main.prefs.set("subLocation",stnName);
		
}