var gGadgetMode = (window.System !== undefined); //if we're in gadget mode or dev. mode
var main = gGadgetMode ? System.Gadget.document.parentWindow : window;

function FloatingContent_loadContent() {
  if (gGadgetMode) gBackground.src = "Images/floatingContent/floatingBackground.png";
  else $('FloatingContent').style.background = "url(Images/floatingContent/floatingBackground.png)";
  
  try {
    
  var floatingContent = main.prefs.get("floatingContentState");
  Gadget_setFloatingContent(floatingContent,true);
  
  var loc = main.prefs.get("loc");
  setWebcamsAndRadar(loc);
  var selCam = main.prefs.get("selectedWebcam");
  if (selCam != "") {
    Gadget_changeWebcam(null,selCam);
  }
  
  document.getElementById('radarTab').innerHTML                   = main.getLocalizedString('Radar');
  document.getElementById('conditionsTab').innerHTML              = main.getLocalizedString('Conditions');
  document.getElementById('wundercamTab').innerHTML               = main.getLocalizedString('Cams');
      
  document.getElementById('cond_windL').innerHTML                 = main.getLocalizedString('Wind');
  document.getElementById('conditions_windchillTitle').innerHTML  = main.getLocalizedString('Windchill');
  document.getElementById('cond_humidityL').innerHTML             = main.getLocalizedString('Humidity');
  document.getElementById('cond_dewpointL').innerHTML             = main.getLocalizedString('Dew Point');
  document.getElementById('cond_pressureL').innerHTML             = main.getLocalizedString('Pressure');
  document.getElementById('cond_visibilityL').innerHTML           = main.getLocalizedString('Visibility');
  
  if (typeof main.CurCond_curCondData !== 'undefined') floatingContent_setCurConds(main.CurCond_curCondData);
  
  } catch(e) {
    main.debug.error("floatingContent: "+e.message);
  } 
}

function Gadget_setFloatingContent(id,noFade) {
	var eles = ['radar','conditions','wundercam'];
	var zIndicies = [3,2,1];
	var ele_id = document.getElementById(id);
  main.prefs.set("floatingContentState",id);

	if (ele_id.style.visibility != "visible") {
		for(var i = 0; i < eles.length; i++) {
			document.getElementById(eles[i]).style.opacity = 0;
			document.getElementById(eles[i] + "Tab").style.zIndex = zIndicies[i];
			document.getElementById(eles[i] + "Tab").style.backgroundImage = "url(Images/floatingContent/tabs/" + eles[i] +"Tab.png)";
			hide(eles[i]);
		}
		
		ele_id.style.visibility = 'visible';
		document.getElementById(id + "Tab").style.zIndex = 4;
		document.getElementById(id + "Tab").style.backgroundImage = "url(Images/floatingContent/tabs/" + id +"Tab_selected.png)";
		
		if (noFade != true && id != "conditions" && id != "wundercam") {
		  Fade(ele_id,null,null,"in");
		} else {
			ele_id.style.opacity = 1;
		}
	}
}
/* Reused functions, probably get rid of */
function hide(id) {document.getElementById(id).style.visibility = "hidden";}
function show(id) {document.getElementById(id).style.visibility = "visible";}
function $() {
	var elements = new Array();
	for (var i = 0; i < arguments.length; i++) {
		var element = arguments[i];
		if (typeof element == 'string')
			element = document.getElementById(element);
		if (arguments.length == 1)
			return element;
		elements.push(element);
	}
	return elements;
}

function Gadget_changeWebcam(evt,manual_select) {
	var wunderimage = document.getElementById('wundercamImage');
	var ws = $('wundercamSelect');
	var loc = main.prefs.get("loc");
	
	//manual_select is for the initial setting from the preferences
	if (manual_select != null) {
	  var selected = manual_select;
	  ws.selectedIndex = selected;
	  
  }	else {
    var selected = ws.selectedIndex;
  }
	
  main.prefs.set("selectedWebcam",selected);
	var url = loc.webcams[selected].url;
	wunderimage.src = url.match(/^(.+time=)/)[1] + now();
	
  wunderimage.onclick = main.linkTo(loc.webcams[selected].camUrl);
	
	var title = loc.webcams[selected].city + " <em>(" + loc.webcams[selected].handle + ")</em>";
	document.getElementById('wundercamTitle').innerHTML = title;
}

function setWebcamsAndRadar(l) {
	//WEBCAMS
	var wunderimage = document.getElementById('wundercamImage');
	var wunderTab = document.getElementById('wundercamTab');
	var wundercamSelect = document.getElementById('wundercamSelect');
	wunderimage.onclick = null;
	
	if (l.webcams && l.webcams.length > 0) {
		
    wunderTab.style.visibility = "visible";
		wunderimage.src = l.webcams[0].url.match(/^(.+time=)/)[1] + now();
    wunderimage.onclick = main.linkTo(l.webcams[0].camUrl);
		var title = l.webcams[0].city+ " <em>(" + l.webcams[0].handle + ")</em>";
		$('wundercamTitle').innerHTML = title;
		
		if (l.webcams.length > 1) {
			var webcamSelect = new Array();
			for(var i = 0; i < l.webcams.length; i++) webcamSelect.push({'name':l.webcams[i].city+ " (" + l.webcams[i].handle + ")"});
			makeSelectBox('wundercamSelect',webcamSelect,Gadget_changeWebcam);
			$('wundercamSelectButton').style.display = "";
		} else {
		  
      main.prefs.set("selectedWebcam",0);
			wundercamSelect.innerHTML = null;
			wundercamSelect.disabled = true;
			$('wundercamSelectButton').style.display = "none";
		}
		
	} else {
	  
    main.prefs.set("selectedWebcam","");
		wundercamSelect.innerHTML = null;
		wundercamSelect.disabled = true;
		$('wundercamSelectButton').style.display = "none";
		
		wunderTab.style.visibility = "hidden";
		if ($('wundercam').style.visibility == 'visible') Gadget_setFloatingContent('conditions',true);
		
	}
	
	
	//RADAR
	if (l.radar) {
	 $('radar').src = (l.radar.image ? l.radar.image.match(/^(.+time=)/)[1] + now() : "Images/blank.png"); 
	}
	
	if (!l.radar || !l.radar.image) {
		
		if ($('radar').style.visibility == 'visible') Gadget_setFloatingContent('conditions',true);
		$('radarTab').style.visibility = "hidden";

	} else {
		
		$('radarTab').style.visibility = "visible";
		
		$('radar').style.border = "1px solid black";
	}
	
	if ($('radarTab').style.visibility == 'hidden' && wunderTab.style.visibility == 'hidden') {
		$('conditionsTab').style.visibility = "hidden";
	} else {
		$('conditionsTab').style.visibility = "visible";
	}
	
	if (l.radar && l.radar.url != null) {
    $('radar').onclick = main.linkTo(l.radar.url);
	}
	
}

function makeSelectBox(id,elements,eventListenerCallback) {
 var ele = document.getElementById(id);
 var option; var select; var txt;

 select = document.createElement('select');
 select.setAttribute("id",id);
 
 for (var i = 0; i < elements.length; i++) {
   option = document.createElement('option');
   option.setAttribute('value',elements[i].value);
   if (elements[i].disabled) {option.setAttribute('disabled','disabled');}
   if (elements[i].selected) {option.setAttribute('selected','selected');}
    option.innerHTML = elements[i].name;
    // txt = document.createTextNode(elements[i].name);
    // option.appendChild(txt);
   select.appendChild(option);
 }

 ele.parentNode.replaceChild(select,ele);

 ele = document.getElementById(id);
 ele.onchange = eventListenerCallback;
}

function floatingContent_setCurConds(cur_conds) {

  var wind = main.unitData(cur_conds.wind,"wind");
  var windchill; var heatindex;
  
  $('conditions_wind').innerHTML = wind + "&nbsp;" + (main.getLocalizedString(cur_conds.windDirection) || "");
 
  var wcTitle = $('conditions_windchillTitle'); var wc = $('conditions_windchill');
  if ((windchill = main.unitData(cur_conds.windchill,"temp")) != "N/A") {
   wcTitle.innerHTML = main.getLocalizedString("Windchill"); wc.innerHTML = windchill;
   wcTitle.style.display = ""; wc.style.display = "";
  } else if ((heatindex = main.unitData(cur_conds.heatindex,"temp")) != "N/A") {
   wcTitle.innerHTML = main.getLocalizedString("Heat Index");
   wc.innerHTML = heatindex;
   wcTitle.style.display = ""; wc.style.display = "";    
  } else {
   wcTitle.style.display = "none";
   wc.style.display = "none";
  }
  
  main.debug.trace("Ps: "+cur_conds.pressure[0]);
 
  var humidity = parseInt(cur_conds.humidity,10);
  $('conditions_humidity').innerHTML = main.unitData([humidity,humidity],"humidity");
  $('conditions_dewpoint').innerHTML = main.unitData(cur_conds.dewpoint,"temp");
  $('conditions_pressure').innerHTML = main.unitData(cur_conds.pressure,"pressure");
  $('conditions_visibility').innerHTML = main.unitData(cur_conds.visibility,"visibility");
  
  if (typeof(cur_conds.conditions_full) != 'undefined' && cur_conds.conditions_full != "NA") {
    $('conditions_conditions').innerHTML = main.getLocalizedString(main.toCapitalCase(cur_conds.conditions_full));
	} else {
    $('conditions_conditions').innerHTML = "";
	} 
}