//icon globals
var ICON_DIR = "Images/wxIcons/";
var SM_ICON_DIR = ICON_DIR + "small/";
var SM_ICON_BLANK = "blank";
var ICON_BLANK = "blank";
var ICON_FILE_TYPE = ".png";
var RADAR_BLANK = "Images/blank.png";
var RADAR_DIM = 130;

function linkTo(linkUrl) {
    return (
      function() { 
        try { //to prevent our sidebar from complaining when VS is installed
          var shell = new ActiveXObject("WScript.Shell");
          shell.Run(linkUrl);
        } catch (e) {}
      }
    );
}

function weekDay(day) {
	var txt;
	
	switch(day) {
		case "Monday": txt = getLocalizedString("MON"); break;
		case "Tuesday": txt = getLocalizedString("TUE"); break;
		case "Wednesday": txt = getLocalizedString("WED"); break;
		case "Thursday": txt = getLocalizedString("THU"); break;
		case "Friday": txt = getLocalizedString("FRI"); break;
		case "Saturday": txt = getLocalizedString("SAT"); break;
		case "Sunday": txt = getLocalizedString("SUN"); break;
		case "---": txt = "---"; break;
		default: txt = day; break;
	}
	return txt;
}

function unitData(element,type) {
	var myUnits = prefs.get("units");
	var txt;
	var range;
	var unit;
	
	switch(type) {
		case "wind": unit = [getLocalizedString("mph"),getLocalizedString("kph")]; range = [0,200]; break;
		case "temp": unit = ["&deg;F","&deg;C"]; range = [-150,150]; break;
		case "bigTemp": unit = ["&deg;","&deg;"]; range = [-150,150]; break;
		case "pressure": unit = [getLocalizedString("in"),getLocalizedString("hpa")]; range = [26,33]; break;
		case "visibility": unit = [getLocalizedString("sm"),getLocalizedString("km")]; range = [0,70]; break;
		case "humidity": unit = ["%","%"]; range = [0,100]; break;
		default: unit = ["",""]; range = null; break;
	}
	
	var BAD_VALUES = ["N/A","NA","null","",null,"-9999.0","-9999"];
	
	if (typeof(element) == "object" && element.length > 0 && 
			inArray(element[0],BAD_VALUES) == false &&
			inArray(element[1],BAD_VALUES) == false && 
			(range == null || element[0] >= range[0] && element[0] <= range[1])
			) {
			  
		if (type == 'bigTemp') {element[0] = Math.round(element[0]); element[1] = Math.round(element[1]);}
		
		var spacing = (inArray(type,["bigTemp","humidity","temp"]) == false ? "&nbsp;" : "");
		
		if (myUnits == 2 && type != "humidity") //both
			txt =  element[0] + (unit[0] ? spacing + unit[0] : "") + "/" + element[1] + (unit[1] ? spacing + unit[1] : "");
		else if (myUnits == 0 || type == 'humidity')
			txt = element[0] + (unit[0] ? spacing + unit[0] : "");
		else
			txt = element[1] + (unit[1] ? spacing + unit[1] : "");
	} else {
		txt = "N/A";
	}
	return txt;
}

function Gadget_determineNightOrDay(moon,cond) {
	
	var nowHours = parseInt(moon.curHour,10) + (moon.curMin / 60);
	var sunset = parseInt(moon.sunsetHour,10) + (moon.sunsetMin / 60); 
	var sunrise = parseInt(moon.sunriseHour,10) + (moon.sunriseMin / 60);
	
	var timeOfDay;
	
	if (nowHours > sunset || nowHours < sunrise) {
	  timeOfDay = "night";
	} else {
    timeOfDay = "day";
	}
	return timeOfDay;
}

function outputLocalWxStnTitle(stn) {
	return ((stn.type == "airport" ? (stn.id != "----" ? stn.id + "\: ":"") : "") +
	(stn.neighborhood ? stn.neighborhood : stn.city + ", " + (stn.state ? stn.state : "") + (stn.country != "US" ? stn.country : "")));	
}